//***************************
//* akIslandDom - RM script
//* Created by AK
//* 2003-1-18 to 2003-2-17
//***************************

// Dominate the islands and rule


// Global constants (copied from AI)
// =================================
//Tech Status:
const int cTechStatusUnobtainable=0;
const int cTechStatusObtainable=1;
const int cTechStatusAvailable=2;
const int cTechStatusResearching=3;
const int cTechStatusActive=4;
const int cTechStatusPersistent=5;

const int cTechArchitects=60;
const int cTechOlympicParentage=161;
const int cTechAthenianWall=242;


// Global variables
// ================
float startPosX=0.0;
float startPosZ=0.0;
float dest1PosX=0.0;
float dest1PosZ=0.0;
float centerPosX=0.0;
float centerPosZ=0.0;
float dest2PosX=0.0;
float dest2PosZ=0.0;
float endPosX=0.0;
float endPosZ=0.0;

float factorX=0.0;
float factorZ=0.0;

int tempArmy = -1;
int tempUnit = -1;
int tempUnitPlaced=-1;

// Declare vars for terrain and objects

string territoryName = "";
string mapTerrainType = "";
string playerTerrainType = "";
string island1TerrainType = "";
string island2TerrainType = "";
string island3TerrainType = "";
string island4TerrainType = "";
string roadTerrainType = "";
string decoTerrainType = "";
string smallLakeWaterType = "";
string middleLakeWaterType = "";
string cliffType = "";
string forestType = "";
string treeType = "";
string specialTreeType = "";
string mapLightType = "";
string startBuildingType = "";
string foodAnimalType = "";
string waterDeco1Type = "";
string deco1ObjectType = "";
string deco2ObjectType = "";
string deco3ObjectType = "";
string cultureObject2Type = "";
string cultureObject3Type = "";
string cultureObject4Type = "";
string cultureObject5Type = "";
string cultureObject6Type = "";
string cultureObject7Type = "";
string fishType = "";
string bigFishType = "";
string bandit1Type = "";
string bandit2Type = "";
string bandit3Type = "";


string akGetHeroUnit(int aPlayer=0)
{
   if(rmGetPlayerCulture(aPlayer) == cCultureGreek) 
      return("Arkantos");
   if(rmGetPlayerCulture(aPlayer) == cCultureNorse) 
      return("Reginleif");
    if(rmGetPlayerCulture(aPlayer) == cCultureEgyptian) 
      return("Amanra");
}

string akGetVillagerUnit(int aPlayer=0)
{
   if(rmGetPlayerCulture(aPlayer) == cCultureGreek) 
      return("Villager Greek");
   if(rmGetPlayerCulture(aPlayer) == cCultureNorse) 
      return("Ulfsark");
    if(rmGetPlayerCulture(aPlayer) == cCultureEgyptian) 
      return("Villager Egyptian");
}

void akCreateBasicTriggers(void)
{
      rmCreateTrigger("Start01");
      rmAddTriggerCondition("Always");

      for(i=1; <= cNumberNonGaiaPlayers)
      {
         rmAddTriggerEffect("Diplomacy");
         rmSetTriggerEffectParamInt("Player1",0);
         rmSetTriggerEffectParamInt("Player2",i);
         rmSetTriggerEffectParam("Status","neutral");
         rmAddTriggerEffect("Diplomacy");
         rmSetTriggerEffectParamInt("Player1",i);
         rmSetTriggerEffectParamInt("Player2",0);
         rmSetTriggerEffectParam("Status","neutral");

      }

      rmSetTriggerPriority(5);
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(true);
      rmSetTriggerLoop(false);

      rmCreateTrigger("Intro00");
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1",0);

      rmAddTriggerEffect("Message");
      rmSetTriggerEffectParam("Text","Welcome to "+territoryName+".");

      rmSetTriggerPriority(2);
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(true);
      rmSetTriggerLoop(false);


      rmCreateTrigger("Intro01");
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1",4);

      rmAddTriggerEffect("Message");
      rmSetTriggerEffectParam("Text","Visit the naval shipyards on the islands with 2 or 3 of your villagers. The people there will give you support.");

      rmSetTriggerPriority(2);
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(true);
      rmSetTriggerLoop(false);
  
      rmCreateTrigger("Intro02");
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1",10);

      rmAddTriggerEffect("Message");
      rmSetTriggerEffectParam("Text","To occupy lighthouses bring 2 military ships nearby. Lighhouses have to be paid for their support.");

      rmSetTriggerPriority(5);
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(true);
      rmSetTriggerLoop(false);

      rmCreateTrigger("Intro03");
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1",25);

      rmAddTriggerEffect("Message");
      rmSetTriggerEffectParam("Text","Let the contest begin.");

      rmSetTriggerPriority(5);
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(true);
      rmSetTriggerLoop(false);
}


void akCreateStartBonusTriggers(void)
{
   for(i=1; <= cNumberNonGaiaPlayers)
   {
      rmCreateTrigger("StartBonus"+"P"+i);
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID", i);
      rmSetTriggerEffectParam("ResName","food");
      rmSetTriggerEffectParamInt("Amount",250);
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID", i);
      rmSetTriggerEffectParam("ResName","gold");
      rmSetTriggerEffectParamInt("Amount",100);
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID", i);
      rmSetTriggerEffectParam("ResName","wood");
      rmSetTriggerEffectParamInt("Amount",250);
      rmSetTriggerPriority(9);
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(true);
      rmSetTriggerLoop(false);
   }
}


void akCreateConvertTrigger(int aSize=-1, int aArmy=-1, int aUnit=-1, int aUnitPlaced=-1)
{

//    rmCreateTrigger("ERR"+aSize+"A"+aArmy+"U"+aUnit+"Up"+aUnitPlaced);
    if (aSize == -1)
      return;

    if (aArmy == -1)
      return;

    if (aUnit == -1)
      return;

    if (aUnitPlaced == -1)
      return;

    if (aSize == 0)
    {
	int minUnits = 3;
        string neededUnit = "AbstractVillager";
    }
    else if (aSize == 1)
    {
	minUnits = 2;
        neededUnit = "AbstractVillager";
    }
    else if (aSize == 2)
    {
	minUnits = 2;
        neededUnit = "LogicalTypeNavalMilitary";
    }
    else if (aSize == 3)
    {
	minUnits = 1;
        neededUnit = "LogicalTypeNavalMilitary";
    }

    for(i=1; <= cNumberNonGaiaPlayers)
    {
      rmCreateTrigger("C"+aSize+"A"+aArmy+"U"+aUnit+"P"+i);
      rmCreateTrigger("O20"+aSize+"A"+aArmy+"U"+aUnit+"P"+i);
    }


    rmCreateTrigger("D"+aSize+"A"+aArmy+"U"+aUnit);
    rmAddTriggerCondition("Is Dead");
    rmSetTriggerConditionParam("SrcObject",""+aUnitPlaced);

    rmAddTriggerEffect("Army Destroy");
    rmSetTriggerEffectParamArmy("SrcArmy",0,aArmy);

    for(i=1; <= cNumberNonGaiaPlayers)
    {
      rmAddTriggerEffect("Disable Trigger");
      rmSetTriggerEffectParam("TrigName","C"+aSize+"A"+aArmy+"U"+aUnit+"P"+i);
      rmSetTriggerEffectParam("TrigName","O20"+aSize+"A"+aArmy+"U"+aUnit+"P"+i);
      rmSetTriggerEffectParam("TrigName","FireC"+aSize+"A"+aArmy+"U"+aUnit);
    }

    rmSetTriggerPriority(8);
    rmSetTriggerActive(true);
    rmSetTriggerRunImmediately(false);
    rmSetTriggerLoop(false);



    for(i=1; <= cNumberNonGaiaPlayers)
    {

      rmSwitchToTrigger(rmTriggerID("C"+aSize+"A"+aArmy+"U"+aUnit+"P"+i));

      for(j=1; <= cNumberNonGaiaPlayers)
      {
         if (i != j)
         {
           rmAddTriggerCondition("Units in Area");
           rmSetTriggerConditionParamInt("Player", j);
           rmSetTriggerConditionParam("DstObject",""+aUnitPlaced);
           rmSetTriggerConditionParam("UnitType",neededUnit);
           rmSetTriggerConditionParamFloat("Dist",10);
           rmSetTriggerConditionParam("Op","<");
           rmSetTriggerConditionParamInt("Count", minUnits);

           rmAddTriggerEffect("Disable Trigger");
           rmSetTriggerEffectParam("TrigName","C"+aSize+"A"+aArmy+"U"+aUnit+"P"+j);
         }
         else
	 {
           rmAddTriggerCondition("Units in Area");
           rmSetTriggerConditionParamInt("Player", j);
           rmSetTriggerConditionParam("DstObject",""+aUnitPlaced);
           rmSetTriggerConditionParam("UnitType",neededUnit);
           rmSetTriggerConditionParamFloat("Dist",15);
           rmSetTriggerConditionParam("Op",">=");
           rmSetTriggerConditionParamInt("Count", minUnits);
	 }
      }

      rmAddTriggerEffect("Army Convert");
      rmSetTriggerEffectParamArmy("SrcArmy",0,aArmy);
      rmSetTriggerEffectParamInt("PlayerID", i);

      rmAddTriggerEffect("Fire Event");
      rmSetTriggerEffectParamInt("EventID", rmTriggerID("O20"+aSize+"A"+aArmy+"U"+aUnit+"P"+i));

      rmSetTriggerPriority(8);
      rmSetTriggerActive(false);
      rmSetTriggerRunImmediately(false);
      rmSetTriggerLoop(false);
    }

    for(i=1; <= cNumberNonGaiaPlayers)
    {
      rmSwitchToTrigger(rmTriggerID("O20"+aSize+"A"+aArmy+"U"+aUnit+"P"+i));
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1",20);

      rmAddTriggerCondition("Army Owned");
      rmSetTriggerConditionParamInt("Player",i);
      rmSetTriggerConditionParamArmy("SrcArmy",0,aArmy);


      if (aSize == 0)
      {
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","food");
         rmSetTriggerEffectParamInt("Amount",20);
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","gold");
         rmSetTriggerEffectParamInt("Amount",30);
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","wood");
         rmSetTriggerEffectParamInt("Amount",40);
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","favor");
         rmSetTriggerEffectParamInt("Amount",20);

      }
      else if (aSize == 1)
      {
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","food");
         rmSetTriggerEffectParamInt("Amount",10);
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","gold");
         rmSetTriggerEffectParamInt("Amount",10);
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","wood");
         rmSetTriggerEffectParamInt("Amount",15);
      }
      else if (aSize == 2)
      {
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","food");
         rmSetTriggerEffectParamInt("Amount",-10);
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","gold");
         rmSetTriggerEffectParamInt("Amount",-10);
      }
      else if (aSize == 3)
      {
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","food");
         rmSetTriggerEffectParamInt("Amount",-5);
         rmAddTriggerEffect("Grant Resources");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("ResName","gold");
         rmSetTriggerEffectParamInt("Amount",-5);
      }

      rmSetTriggerPriority(8);
      rmSetTriggerActive(false);
      rmSetTriggerRunImmediately(false);
      rmSetTriggerLoop(true);
    }

    rmCreateTrigger("FireC"+aSize+"A"+aArmy+"U"+aUnit);
    rmAddTriggerCondition("Timer");
    if (aSize == 0)
    {
	rmSetTriggerConditionParamInt("Param1",60);
    }
    else if (aSize == 1)
    {
	rmSetTriggerConditionParamInt("Param1",40);
    }
    else if (aSize == 2)
    {
	rmSetTriggerConditionParamInt("Param1",30);
    }
    else if (aSize == 3)
    {
	rmSetTriggerConditionParamInt("Param1",20);
    }

    for(i=1; <= cNumberNonGaiaPlayers)
    {
      rmAddTriggerEffect("Fire Event");
      rmSetTriggerEffectParamInt("EventID", rmTriggerID("C"+aSize+"A"+aArmy+"U"+aUnit+"P"+i));

      rmSetTriggerPriority(3);
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(false);
      rmSetTriggerLoop(true);
    }
}

void akCreatePlayerHome(int aPlayer=0, int aArea=0, string aStart="", string aHero="")
{
    int waterConstraint=rmCreateTerrainDistanceConstraint("avoid water"+aPlayer, "water", true, 8.0);

    float lPosX = rmPlayerLocXFraction(aPlayer);
    float lPosZ = rmPlayerLocZFraction(aPlayer);
 
    int startingSettlementID=rmCreateObjectDef("Starting settlement"+aPlayer);
    rmAddObjectDefItem(startingSettlementID, aStart, 1, 0.0);
    rmAddObjectDefItem(startingSettlementID, "Gold Mine", 1, 8.0);
    rmAddObjectDefItem(startingSettlementID, treeType, 5, 10.0);
    rmAddObjectDefToClass(startingSettlementID, rmClassID("starting settlement"));
    rmAddObjectDefToClass(startingSettlementID, rmClassID("player"));
    rmSetObjectDefMinDistance(startingSettlementID, 0.0);
    rmSetObjectDefMaxDistance(startingSettlementID, 0.0);
    rmAddObjectDefConstraint(startingSettlementID, waterConstraint);
    rmPlaceObjectDefInArea(startingSettlementID, aPlayer, aArea, 1); 

//    lUnitPlaced = rmGetUnitPlaced(startingSettlementID,0);

/*
    if (lPosX <= 0.5)
      lPosX = lPosX + 0.03;
    else if (lPosX > 0.5)
      lPosX = lPosX - 0.03;
    if (lPosZ <= 0.5)
      lPosZ = lPosZ + 0.03;
    else if (lPosZ > 0.5)
      lPosZ = lPosZ - 0.03;

    rmPlaceObjectDefAtLoc(startingSettlementID, aPlayer, lPosX, lPosZ, 1);
*/

/*
    int heroID=rmCreateObjectDef("Hero"+aPlayer);
    rmAddObjectDefItem(heroID, aHero, 1, 0.0);
    rmAddObjectDefToClass(heroID, rmClassID("starting settlement"));
    rmAddObjectDefToClass(heroID, rmClassID("player"));
    rmSetObjectDefMinDistance(heroID, 10.0);
    rmSetObjectDefMaxDistance(heroID, 20.0);
    rmPlaceObjectDefInArea(heroID, aPlayer, aArea, 1); 
*/
//    rmAddUnitsToArmy(aPlayer,lStartArmy,heroID);

//    rmPlaceObjectDefAtLoc(heroID, aPlayer, lPosX, lPosZ, 1);


    int dockID=rmCreateObjectDef("Dock"+aPlayer);
    rmAddObjectDefItem(dockID, "Dock", 1, 0.0);
    rmAddObjectDefToClass(dockID, rmClassID("starting settlement"));
    rmAddObjectDefToClass(dockID, rmClassID("player"));
    rmSetObjectDefMinDistance(dockID, 0.0);
    rmSetObjectDefMaxDistance(dockID, 30.0);
    rmPlaceObjectDefInArea(dockID, aPlayer, aArea, 1); 


    int goldID=rmCreateObjectDef("GoldAndTree"+aPlayer);
    rmAddObjectDefItem(goldID, "Gold Mine", 1, 0.0);
    rmAddObjectDefItem(goldID, treeType, 20, 20.0);
    rmAddObjectDefToClass(goldID, rmClassID("starting settlement"));
    rmAddObjectDefToClass(goldID, rmClassID("player"));
    rmSetObjectDefMinDistance(goldID, 0.0);
    rmSetObjectDefMaxDistance(goldID, 30.0);
    rmPlaceObjectDefInArea(goldID, 0, aArea, 1); 

/*

    if (lPosX <= 0.5)
      lPosX = lPosX + 0.025;
    else if (lPosX > 0.5)
      lPosX = lPosX - 0.025;
    if (lPosZ <= 0.5)
      lPosZ = lPosZ + 0.025;
    else if (lPosZ > 0.5)
      lPosZ = lPosZ - 0.025;
    rmPlaceObjectDefAtLoc(dockID, aPlayer, lPosX, lPosZ, 1);
*/
}

// Main entry point for random map script
void main(void)
{
   // Text
   rmSetStatusText("",0.01);

   // Set size.
   int playerTiles=8000;
   if(cMapSize == 1)
   {
      playerTiles = 10000;
      rmEchoInfo("Large map");
   }
   int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
   rmEchoInfo("Map size="+size+"m x "+size+"m");
   rmSetMapSize(size, size);



// ----------Randomize terrain

   rmSetStatusText("",0.20);

   startBuildingType = "Settlement Level 1";

   int randomSet = rmRandInt(1,3);
   switch (randomSet)
   {
     case 1:
	{
           territoryName = "the Greek Island Mastership.";
	   mapLightType = "Fimbulwinter";
	   mapTerrainType = "GreekRoadA";
	   roadTerrainType = "GreekRoadA";
	   playerTerrainType = "CityTileA";
	   island1TerrainType = "GrassA";
 	   island2TerrainType = "GrassB";
	   island3TerrainType = "GrassDirt25";
	   island4TerrainType = "HadesCliff";
	   decoTerrainType = "GrassB";
	   smallLakeWaterType = "Greek River";
//	   middleLakeWaterType = "Greek River";
//	   middleLakeWaterType = "Mediterranean Sea";
	   middleLakeWaterType = "Aegean Sea";
	   cliffType = "Greek";
	   forestType = "Mixed Oak Forest";
	   treeType = "Oak Tree";
	   specialTreeType = "Savannah Tree";
   	   bandit1Type = "Wolf";
	   bandit2Type = "Bear";
	   foodAnimalType = "Pig";
	   fishType = "Fish - Perch";
	   bigFishType = "Shark";
	   waterDeco1Type = "Water Lilly";
	   deco1ObjectType = "Shrine";
	   deco2ObjectType = "Columns";
	   deco3ObjectType = "Columns Fallen";
	   cultureObject2Type = "Shrine";
	   cultureObject3Type = "Statue of Major God";
	   cultureObject4Type = "Statue of Major God";
	   cultureObject5Type = "Mist";
	   cultureObject6Type = "Columns";
	   cultureObject7Type = "Fountain";
	   break;
	}
     case 2:
	{
           territoryName = "the Egyptian Nile Flood Rush.";
	   mapLightType = "Ghost Lake";
	   mapTerrainType = "EgyptianRoadA";
	   playerTerrainType = "GrassDirt75";
	   island1TerrainType = "GrassDirt50";
 	   island2TerrainType = "SavannahA";
	   island3TerrainType = "GrassDirt75";
	   island4TerrainType = "SandB";
	   roadTerrainType = "EgyptianRoadA";
	   decoTerrainType = "SandA";
	   smallLakeWaterType = "Savannah Water Hole";
//	   middleLakeWaterType = "Savannah Water Hole";
	   middleLakeWaterType = "Red Sea";
	   cliffType = "Egyptian";
	   forestType = "Savannah Forest";
	   treeType = "Palm";
	   specialTreeType = "Palm";
   	   bandit1Type = "Hyena";
	   bandit2Type = "Lion";
	   foodAnimalType = "Chicken";
	   fishType = "Fish - Mahi";
	   bigFishType = "Orca";
	   waterDeco1Type = "Papyrus";
	   deco1ObjectType = "Statue Pharaoh";
	   deco2ObjectType = "Mist";
	   deco3ObjectType = "Milestone";
	   cultureObject2Type = "Statue Pharaoh";
	   cultureObject3Type = "Statue Lion Left";
	   cultureObject4Type = "Statue Lion Right";
	   cultureObject5Type = "Mist";
	   cultureObject6Type = "Tent";
	   cultureObject7Type = "Fountain";
	   break;
	}
     case 3:
	{
           territoryName = "the Norse Fjord Domination.";
	   mapLightType = "Alfheim";
	   mapTerrainType = "NorseRoadA";
	   playerTerrainType = "SnowGrass75";
	   island1TerrainType = "SnowGrass75";
 	   island2TerrainType = "GrassB";
	   island3TerrainType = "SnowGrass50";
	   island4TerrainType = "IceA";
	   roadTerrainType = "NorseRoadA";
	   decoTerrainType = "SnowGrass50";
	   smallLakeWaterType = "Norse River";
	   middleLakeWaterType = "Norse River";
//	   middleLakeWaterType = "Norwegian Sea";
//	   middleLakeWaterType = "North Atlantic Ocean";
	   cliffType = "Norse";
	   forestType = "Snow Pine Forest";
	   treeType = "Pine Snow";
	   specialTreeType = "Oak Tree";
   	   bandit1Type = "Wolf";
	   bandit2Type = "Fenris Wolf";
	   foodAnimalType = "Cow";
	   fishType = "Fish - Salmon";
	   bigFishType = "Whale";
	   waterDeco1Type = "Water Lilly";
	   deco1ObjectType = "Taproot Small";
	   deco2ObjectType = "Lightning Cloud";
	   deco3ObjectType = "Ice block";
	   cultureObject2Type = "Longhouse";
	   cultureObject3Type = "Campfire";
	   cultureObject4Type = "Runestone";
	   cultureObject5Type = "Mist";
	   cultureObject6Type = "Rotting Log";
	   cultureObject7Type = "Rock Granite Small";
	   break;
	}
   }

   // Set up default water.
   rmSetSeaLevel(-0.5);

   // Init map.
   rmSetSeaType(middleLakeWaterType);
//   rmTerrainInitialize(mapTerrainType);
   rmTerrainInitialize("water");
   rmSetLightingSet(mapLightType);
   rmSetGaiaCiv(cCivZeus);
   rmSetVCFile("akIslandDomVC");

   // Define some classes.
   int classPlayer=rmDefineClass("player");
   rmDefineClass("classHill");
   int startSettle = rmDefineClass("starting settlement");
   int classArea=rmDefineClass("Area");
   int classWater=rmDefineClass("Water");
   int classForest=rmDefineClass("forest");
   int classSpecial=rmDefineClass("special");
   int classRoad=rmDefineClass("road");
   int classDistrict=rmDefineClass("District");



    // -------------Define constraints

   // Create a edge of map constraint.
//   int nearEdgeConstraint=rmCreateBoxConstraint("near edge of map", rmXMetersToFraction(320), rmZMetersToFraction(320), 1.0-rmXMetersToFraction(320), 1.0-rmZMetersToFraction(320));
//   int edgeConstraint=rmCreateBoxConstraint("far edge of map", rmXMetersToFraction(320), rmZMetersToFraction(320), 1.0-rmXMetersToFraction(320), 1.0-rmZMetersToFraction(320));
   int edgeConstraint=rmCreateBoxConstraint("edge of map", rmXTilesToFraction(3), rmZTilesToFraction(3), 1.0-rmXTilesToFraction(3), 1.0-rmZTilesToFraction(3));
   int nearEdgeConstraint=rmCreateBoxConstraint("near edge of map", rmXTilesToFraction(1), rmZTilesToFraction(1), 1.0-rmXTilesToFraction(1), 1.0-rmZTilesToFraction(1));

   // Player area constraint.
   int shortPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a little", classPlayer, 5);
   int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 20);


   // my special constraints
   int nearAreaConstraint=rmCreateClassDistanceConstraint("avoid near areas", classArea, 10.0);
   int medAreaConstraint=rmCreateClassDistanceConstraint("avoid med areas", classArea, 15.0);
   int farAreaConstraint=rmCreateClassDistanceConstraint("avoid far areas", classArea, 20.0);

   int atWaterConstraint=rmCreateTerrainDistanceConstraint("at water", "water", true, 0.0);
   int nearWaterConstraint=rmCreateTerrainDistanceConstraint("near water", "water", true, 2.0);
   int medWaterConstraint=rmCreateTerrainDistanceConstraint("med water", "water", true, 5.0);
   int farWaterConstraint=rmCreateTerrainDistanceConstraint("far water", "water", true, 8.0);

   int avoidSpecialConstraint=rmCreateClassDistanceConstraint("avoid special", classSpecial, 8.0);
   int avoidRoadConstraint=rmCreateClassDistanceConstraint("avoid road", classRoad, 3.0);


   // Forest constraint.
   int shortForestConstraint=rmCreateClassDistanceConstraint("avoid Forest", classForest, 7);
   int medForestConstraint=rmCreateClassDistanceConstraint("avoid Forest more ", classForest, 15);

   // Settlement constraint.
   int shortAvoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC by short distance", "AbstractSettlement", 7.0);
   int farAvoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC by long distance", "AbstractSettlement", 50.0);
   int farStartingSettleConstraint=rmCreateClassDistanceConstraint("objects avoid player TCs", rmClassID("starting settlement"), 50.0);

   // Tower constraint.
   int avoidTower=rmCreateTypeDistanceConstraint("towers avoid towers", "tower", 20.0);
   int avoidTower2=rmCreateTypeDistanceConstraint("objects avoid towers", "tower", 22.0);

   // District Constraint.
   int shortAvoidDistrict=rmCreateClassDistanceConstraint("short avoid revealer", classDistrict, 7.0);
   int avoidDistrict=rmCreateClassDistanceConstraint("avoid revealer", classDistrict, 12.0);

   // Gold
   int avoidGold=rmCreateTypeDistanceConstraint("avoid gold", "gold", 30.0);
   int shortAvoidGold=rmCreateTypeDistanceConstraint("gold vs. gold", "gold", 24.0);

   // Herd animals
   int avoidHerdable=rmCreateTypeDistanceConstraint("avoid herdable", "herdable", 20.0);
   int avoidFood=rmCreateTypeDistanceConstraint("avoid food", "food", 12.0);
   int avoidPredator=rmCreateTypeDistanceConstraint("avoid predator", "animalPredator", 40.0);

   // Avoid impassable land
   int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "land", false, 8.0);
   int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "land", false, 7.0);

   int avoidBuildings=rmCreateTypeDistanceConstraint("avoid buildings", "Building", 20.0);
   int shortAvoidBuildings=rmCreateTypeDistanceConstraint("short avoid buildings", "Building", 3.0);

// deco constraint
   int decoVsDecoID=rmCreateTypeDistanceConstraint("special v special", deco1ObjectType, 25);

   rmSetStatusText("",0.40);

   // -------------Define objects
   // Close Objects


   // ---Basic Triggers
   akCreateBasicTriggers();
   akCreateStartBonusTriggers();

   // Set up player areas.
   float playerFraction=rmAreaTilesToFraction(4000);
   int randI=rmRandInt(1,cNumberNonGaiaPlayers);

   int transportNearShore=rmCreateTerrainMaxDistanceConstraint("transport near shore", "land", true, 4.0);
   int transportAvoidLand = rmCreateTerrainDistanceConstraint("transport avoid land", "land", true, 1.0);

   int transportGreekID=rmCreateObjectDef("transport greek");
   rmAddObjectDefItem(transportGreekID, "transport ship greek", 2, 20.0);
   rmSetObjectDefMinDistance(transportGreekID, 0.0);
   rmSetObjectDefMaxDistance(transportGreekID, 55.0);
   rmAddObjectDefConstraint(transportGreekID, transportNearShore);
   rmAddObjectDefConstraint(transportGreekID, transportAvoidLand);
   rmAddObjectDefConstraint(transportGreekID, edgeConstraint);
 
   int transportNorseID=rmCreateObjectDef("transport Norse");
   rmAddObjectDefItem(transportNorseID, "transport ship Norse", 2, 20.0);
   rmSetObjectDefMinDistance(transportNorseID, 0.0);
   rmSetObjectDefMaxDistance(transportNorseID, 55.0);
   rmAddObjectDefConstraint(transportNorseID, transportNearShore);
   rmAddObjectDefConstraint(transportNorseID, transportAvoidLand);
   rmAddObjectDefConstraint(transportNorseID, edgeConstraint);
  
   int transportEgyptianID=rmCreateObjectDef("transport Egyptian");
   rmAddObjectDefItem(transportEgyptianID, "transport ship Egyptian", 2, 20.0);
   rmSetObjectDefMinDistance(transportEgyptianID, 0.0);
   rmSetObjectDefMaxDistance(transportEgyptianID, 55.0);
   rmAddObjectDefConstraint(transportEgyptianID, transportNearShore);
   rmAddObjectDefConstraint(transportEgyptianID, transportAvoidLand);
   rmAddObjectDefConstraint(transportEgyptianID, edgeConstraint);


   for(i=1; <cNumberPlayers)
   {
      // Create the player islands.
      int id=rmCreateArea("Player"+i);

      // Set the location.
      if ((randI+i)%cNumberNonGaiaPlayers == 0)
        rmPlacePlayer(i, 0.03, 0.97);
      else if ((randI+i)%cNumberNonGaiaPlayers == 1)
        rmPlacePlayer(i, 0.97, 0.03);
      else if ((randI+i)%cNumberNonGaiaPlayers == 2)
        rmPlacePlayer(i, 0.97, 0.97);
      else if ((randI+i)%cNumberNonGaiaPlayers == 3)
        rmPlacePlayer(i, 0.03, 0.03);
      else if ((randI+i)%cNumberNonGaiaPlayers == 4)
        rmPlacePlayer(i, 0.03, 0.5);
      else if ((randI+i)%cNumberNonGaiaPlayers == 5)
        rmPlacePlayer(i, 0.97, 0.5);
      else if ((randI+i)%cNumberNonGaiaPlayers == 6)
        rmPlacePlayer(i, 0.5, 0.03);
      else if ((randI+i)%cNumberNonGaiaPlayers == 8)
        rmPlacePlayer(i, 0.5, 0.97);

      // Assign to the player.
      rmSetAreaLocPlayer (id, i);
      rmSetPlayerArea(i, id);

      // Set the size.
      rmSetAreaSize(id, 0.2*playerFraction, 0.2*playerFraction);

      rmAddAreaToClass(id, classPlayer);
//      rmSetAreaWarnFailure(id, false);

      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 2);
      rmSetAreaMinBlobDistance(id, 2.0);
      rmSetAreaMaxBlobDistance(id, 30.0);
      rmSetAreaCoherence(id, 0.7);

      rmSetAreaBaseHeight(id, 0.3);
      rmSetAreaHeightBlend(id, 2);
      rmSetAreaSmoothDistance(id, 20);

      // Set type.
      rmSetAreaTerrainType(id, playerTerrainType);
//      rmAddAreaTerrainLayer(id, decoTerrainType, 0, 8);

      rmAddAreaToClass(id, classArea);
      rmAddAreaConstraint(id, nearEdgeConstraint);
      rmBuildArea(id);

      // Slight Elevation
      int numTries=5;
      int failCount=0;
      for(j=0; <numTries)
      {
        int elevID=rmCreateArea("playerwrinkle"+i+"_"+j, id);
        rmSetAreaSize(elevID, rmAreaTilesToFraction(5), rmAreaTilesToFraction(25));
        rmSetAreaWarnFailure(elevID, false);
        rmSetAreaBaseHeight(elevID, rmRandFloat(0.4, 0.8));
//      rmSetAreaTerrainType(elevID, "GrassDirt50");
//      rmAddAreaTerrainLayer(elevID, "GrassDirt25", 0, 1);
        rmSetAreaMinBlobs(elevID, 1);
        rmSetAreaMaxBlobs(elevID, 3);
        rmSetAreaHeightBlend(elevID, 1.0);
        rmAddAreaConstraint(elevID, atWaterConstraint);
        rmSetAreaMinBlobDistance(elevID, 2.0);
        rmSetAreaMaxBlobDistance(elevID, 10.0);
        rmSetAreaCoherence(elevID, 0.0);

        if(rmBuildArea(elevID)==false)
        {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
            break;
         else
	    failCount=0;
        }
      }

      akCreatePlayerHome (i, id, startBuildingType, akGetHeroUnit(i));

   }

  rmSetStatusText("",0.60);
 
  for(i=0; <8*(cNumberNonGaiaPlayers))
   {
      // Island 
      int id2=rmCreateArea("Island"+i);
      tempArmy = rmCreateArmy(0,"Island"+i);
      tempUnit = -1;

      switch (rmRandInt(1,3))
      {
	case 1:
	{
	   rmSetAreaTerrainType(id2, island1TerrainType);
	   break;
        }
	case 2:
	{
	   rmSetAreaTerrainType(id2, island2TerrainType);
	   break;
        }
	case 3:
	{
	   rmSetAreaTerrainType(id2, island3TerrainType);
	   break;
        }
      }
 
      int islandSize = i%4;      
      switch (islandSize)
      {
	case 0:
	{
           rmSetAreaSize(id2, rmAreaTilesToFraction(500), rmAreaTilesToFraction(500));
           rmAddAreaConstraint(id2, medAreaConstraint);
           rmSetAreaHeightBlend(id2, 2);  
           break;
        }
	case 1:
	{
           rmSetAreaSize(id2, rmAreaTilesToFraction(350), rmAreaTilesToFraction(350));
           rmSetAreaHeightBlend(id2, 1);  
           rmAddAreaConstraint(id2, nearAreaConstraint);
	   break;
        }
	case 2:
	{
           rmAddAreaConstraint(id2, farAreaConstraint);
           rmSetAreaSize(id2, rmAreaTilesToFraction(250), rmAreaTilesToFraction(250));
           rmSetAreaHeightBlend(id2, 2);  
	   break;
        }
	case 3:
	{
           rmAddAreaConstraint(id2, nearAreaConstraint);
           rmSetAreaSize(id2, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
           rmSetAreaHeightBlend(id2, 1);  
	   break;
        }
      }
      
      rmSetAreaWarnFailure(id2, false);

      rmSetAreaMinBlobs(id2, 1);
      rmSetAreaMaxBlobs(id2, 2);
      rmSetAreaMinBlobDistance(id2, 2.0);
      rmSetAreaMaxBlobDistance(id2, 20.0);

      float lastHeight=rmRandFloat(0.5, 0.7);
      rmSetAreaCoherence(id2, 0.7);
      rmSetAreaBaseHeight(id2, lastHeight);
      rmSetAreaSmoothDistance(id2, 5);


      rmAddAreaConstraint(id2, shortPlayerConstraint);
//      rmAddAreaConstraint(id2, medForestConstraint);
      rmAddAreaConstraint(id2, edgeConstraint);

      rmBuildArea(id2); 
      rmAddAreaToClass(id2, classArea);
      rmAddAreaToClass(id2, classForest);


      // Slight Elevation
      numTries=5;
      failCount=0;
      for(j=0; <numTries)
      {
        elevID=rmCreateArea("wrinkle"+i+"_"+j, id2);
        rmSetAreaSize(elevID, rmAreaTilesToFraction(5), rmAreaTilesToFraction(25));
        rmSetAreaWarnFailure(elevID, false);
        rmSetAreaBaseHeight(elevID, rmRandFloat(lastHeight + 0.1, lastHeight + 0.4));
//      rmSetAreaTerrainType(elevID, "GrassDirt50");
//      rmAddAreaTerrainLayer(elevID, "GrassDirt25", 0, 1);
        rmSetAreaMinBlobs(elevID, 1);
        rmSetAreaMaxBlobs(elevID, 3);
        rmSetAreaHeightBlend(elevID, 1.0);
        rmAddAreaConstraint(elevID, atWaterConstraint);
        rmSetAreaMinBlobDistance(elevID, 2.0);
        rmSetAreaMaxBlobDistance(elevID, 10.0);
        rmSetAreaCoherence(elevID, 0.0);

        if(rmBuildArea(elevID)==false)
        {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
            break;
         else
	    failCount=0;
        }
      }


      switch (islandSize)
      {
	case 0:
	{
           int islandObject1ID=rmCreateObjectDef("IslObj1_"+i);
           rmAddObjectDefItem(islandObject1ID, "Naval Shipyard", 1, 0.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 30);
	   rmAddObjectDefConstraint(islandObject1ID, atWaterConstraint);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 
           rmAddUnitsToArmy(0,tempArmy,islandObject1ID);
           tempUnit = islandObject1ID;

           islandObject1ID=rmCreateObjectDef("IslObj2_"+i);
           rmAddObjectDefItem(islandObject1ID, "Settlement", 1, 0.0);
           rmAddObjectDefItem(islandObject1ID, "Farm", 1, 8.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 20);
	   rmAddObjectDefConstraint(islandObject1ID, medWaterConstraint);
	   rmAddObjectDefConstraint(islandObject1ID, shortAvoidBuildings);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 

           islandObject1ID=rmCreateObjectDef("IslObj3a_"+i);
           rmAddObjectDefItem(islandObject1ID, "Fortress", 1, 0.0);
           rmAddObjectDefItem(islandObject1ID, "Tower", 2, 8.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 20);
	   rmAddObjectDefConstraint(islandObject1ID, nearWaterConstraint);
	   rmAddObjectDefConstraint(islandObject1ID, shortAvoidBuildings);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 
           rmAddUnitsToArmy(0,tempArmy,islandObject1ID);

           islandObject1ID=rmCreateObjectDef("IslObj3b_"+i);
           rmAddObjectDefItem(islandObject1ID, "Temple", 1, 0.0);
           rmAddObjectDefItem(islandObject1ID, "Columns", 2, 6.0);
           rmAddObjectDefItem(islandObject1ID, foodAnimalType, 8, 12.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 20);
	   rmAddObjectDefConstraint(islandObject1ID, nearWaterConstraint);
	   rmAddObjectDefConstraint(islandObject1ID, shortAvoidBuildings);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 
           rmAddUnitsToArmy(0,tempArmy,islandObject1ID);

           islandObject1ID=rmCreateObjectDef("IslObj4_"+i);
           rmAddObjectDefItem(islandObject1ID, "Gold Mine", 1, 0.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 30);
	   rmAddObjectDefConstraint(islandObject1ID, nearWaterConstraint);
	   rmAddObjectDefConstraint(islandObject1ID, shortAvoidBuildings);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 

           islandObject1ID=rmCreateObjectDef("IslObj5_"+i);
           rmAddObjectDefItem(islandObject1ID, "House", 3, 6.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 30);
	   rmAddObjectDefConstraint(islandObject1ID, nearWaterConstraint);
	   rmAddObjectDefConstraint(islandObject1ID, shortAvoidBuildings);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 
           rmAddUnitsToArmy(0,tempArmy,islandObject1ID);

           islandObject1ID=rmCreateObjectDef("IslObj6_"+i);
           rmAddObjectDefItem(islandObject1ID, "House", 3, 6.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 30);
	   rmAddObjectDefConstraint(islandObject1ID, nearWaterConstraint);
	   rmAddObjectDefConstraint(islandObject1ID, shortAvoidBuildings);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 
           rmAddUnitsToArmy(0,tempArmy,islandObject1ID);

 	   break;
        } 
	case 1:
	{
           islandObject1ID=rmCreateObjectDef("IslObj1_"+i);
           rmAddObjectDefItem(islandObject1ID, "Naval Shipyard", 1, 0.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 30);
	   rmAddObjectDefConstraint(islandObject1ID, atWaterConstraint);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 
           rmAddUnitsToArmy(0,tempArmy,islandObject1ID);
           tempUnit = islandObject1ID;

           islandObject1ID=rmCreateObjectDef("IslObj2_"+i);
           rmAddObjectDefItem(islandObject1ID, "Granary", 1, 0.0);
           rmAddObjectDefItem(islandObject1ID, "Farm", 2, 6.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 30);
	   rmAddObjectDefConstraint(islandObject1ID, medWaterConstraint);
	   rmAddObjectDefConstraint(islandObject1ID, shortAvoidBuildings);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 
           rmAddUnitsToArmy(0,tempArmy,islandObject1ID);

           islandObject1ID=rmCreateObjectDef("IslObj3_"+i);
           rmAddObjectDefItem(islandObject1ID, "Market", 1, 0.0);
           rmAddObjectDefItem(islandObject1ID, "Pots", 5, 7.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 30);
	   rmAddObjectDefConstraint(islandObject1ID, nearWaterConstraint);
	   rmAddObjectDefConstraint(islandObject1ID, shortAvoidBuildings);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 
           rmAddUnitsToArmy(0,tempArmy,islandObject1ID);

           islandObject1ID=rmCreateObjectDef("IslObj4_"+i);
           rmAddObjectDefItem(islandObject1ID, treeType, 10, 7.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 30);
	   rmAddObjectDefConstraint(islandObject1ID, nearWaterConstraint);
	   rmAddObjectDefConstraint(islandObject1ID, shortAvoidBuildings);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 

           islandObject1ID=rmCreateObjectDef("IslObj5_"+i);
           rmAddObjectDefItem(islandObject1ID, "tower", 1, 20.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 30);
	   rmAddObjectDefConstraint(islandObject1ID, nearWaterConstraint);
	   rmAddObjectDefConstraint(islandObject1ID, shortAvoidBuildings);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 2); 
           rmAddUnitsToArmy(0,tempArmy,islandObject1ID);

           islandObject1ID=rmCreateObjectDef("IslObj6_"+i);
           rmAddObjectDefItem(islandObject1ID, "House", 3, 6.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 30);
	   rmAddObjectDefConstraint(islandObject1ID, atWaterConstraint);
	   rmAddObjectDefConstraint(islandObject1ID, shortAvoidBuildings);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 
           rmAddUnitsToArmy(0,tempArmy,islandObject1ID);

           islandObject1ID=rmCreateObjectDef("IslObj7_"+i);
           rmAddObjectDefItem(islandObject1ID, "Gold Mine", 1, 10.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 30);
	   rmAddObjectDefConstraint(islandObject1ID, atWaterConstraint);
	   rmAddObjectDefConstraint(islandObject1ID, shortAvoidBuildings);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 
 	   break;
        } 
	case 2:
	{
           islandObject1ID=rmCreateObjectDef("IslObj1_"+i);
           rmAddObjectDefItem(islandObject1ID, "Lighthouse", 1, 0.0);
           rmAddObjectDefItem(islandObject1ID, "Milestone", 4, 6.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 30);
	   rmAddObjectDefConstraint(islandObject1ID, nearWaterConstraint);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 
           rmAddUnitsToArmy(0,tempArmy,islandObject1ID);
           tempUnit = islandObject1ID;

           islandObject1ID=rmCreateObjectDef("IslObj2_"+i);
           rmAddObjectDefItem(islandObject1ID, "Fortress", 1, 0.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 30);
	   rmAddObjectDefConstraint(islandObject1ID, nearWaterConstraint);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 
           rmAddUnitsToArmy(0,tempArmy,islandObject1ID);

           islandObject1ID=rmCreateObjectDef("IslObj3_"+i);
           rmAddObjectDefItem(islandObject1ID, treeType, 5, 0.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 30);
	   rmAddObjectDefConstraint(islandObject1ID, nearWaterConstraint);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 
 	   break;
        } 
	case 3:
	{
           islandObject1ID=rmCreateObjectDef("IslObj1_"+i);
           rmAddObjectDefItem(islandObject1ID, "Lighthouse", 1, 0.0);
           rmAddObjectDefItem(islandObject1ID, "Milestone", 4, 6.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 30);
	   rmAddObjectDefConstraint(islandObject1ID, nearWaterConstraint);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 
           rmAddUnitsToArmy(0,tempArmy,islandObject1ID);
           tempUnit = islandObject1ID;

           islandObject1ID=rmCreateObjectDef("IslObj2_"+i);
           rmAddObjectDefItem(islandObject1ID, "Tower", 1, 6.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 30);
	   rmAddObjectDefConstraint(islandObject1ID, nearWaterConstraint);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 
           rmAddUnitsToArmy(0,tempArmy,islandObject1ID);

           islandObject1ID=rmCreateObjectDef("IslObj3_"+i);
           rmAddObjectDefItem(islandObject1ID, treeType, 5, 0.0);
           rmSetObjectDefMinDistance(islandObject1ID, 0.0);
           rmSetObjectDefMaxDistance(islandObject1ID, 30);
	   rmAddObjectDefConstraint(islandObject1ID, nearWaterConstraint);
           rmPlaceObjectDefInArea(islandObject1ID, 0, id2, 1); 

 	   break;
        } 
      }
   // deco

      int decoID=rmCreateObjectDef("deco1_"+i);
      rmAddObjectDefItem(decoID, deco1ObjectType, 1, 0.0);
      rmAddObjectDefItem(decoID, deco2ObjectType, 1, 10.0);
      rmAddObjectDefItem(decoID, deco3ObjectType, 2, 6.0);
      rmAddObjectDefItem(decoID, "relic", 1, 6.0);
      rmAddObjectDefItem(decoID, treeType, 4, 6.0);
      rmSetObjectDefMinDistance(decoID, 0.0);
      rmSetObjectDefMaxDistance(decoID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(decoID, decoVsDecoID);
      rmAddObjectDefConstraint(decoID, rmCreateEdgeConstraint("deco1 in edge"+i, id2));
      rmAddObjectDefConstraint(decoID, atWaterConstraint);
      rmAddObjectDefConstraint(decoID, shortAvoidBuildings);
      rmPlaceObjectDefInArea(decoID, 0, id2, 2); 

      tempUnitPlaced=rmGetUnitPlaced(tempUnit,0);
      rmAddUnitsToArmy(0,tempArmy,tempUnit);
      akCreateConvertTrigger(islandSize, tempArmy,tempUnit,tempUnitPlaced);

   }


   // NearGold
   int goldVsGoldID=rmCreateTypeDistanceConstraint("gold vs gold", "Gold Mine", 20.0);

   int playerGoldID=rmCreateObjectDef("PlayerGold");
   rmAddObjectDefItem(playerGoldID, "Gold Mine", 1, 0.0);
   rmSetObjectDefMinDistance(playerGoldID, 10.0);
   rmSetObjectDefMaxDistance(playerGoldID, 30);
   rmAddObjectDefConstraint(playerGoldID, goldVsGoldID);
   rmAddObjectDefConstraint(playerGoldID, avoidImpassableLand);
   rmAddObjectDefConstraint(playerGoldID, avoidSpecialConstraint);
   rmAddObjectDefConstraint(playerGoldID, shortAvoidBuildings);
   rmAddObjectDefConstraint(playerGoldID, shortPlayerConstraint);
   rmPlaceObjectDefPerPlayer(playerGoldID, false, 3);
//   rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers); 


// tree
   int treeVsTreeID=rmCreateTypeDistanceConstraint("tree v tree", "tree", 30);

   int treeID=rmCreateObjectDef("tree");
   rmAddObjectDefItem(treeID, treeType, 7, 5.0);
   rmSetObjectDefMinDistance(treeID, 0.0);
   rmSetObjectDefMaxDistance(treeID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(treeID, treeVsTreeID);
   rmAddObjectDefConstraint(treeID, atWaterConstraint);
   rmAddObjectDefConstraint(treeID, shortAvoidBuildings);
   rmPlaceObjectDefAtLoc(treeID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);


   int wrinkleLand = rmCreateTerrainDistanceConstraint("wrinkle land", "land", true, 15.0);

      // Slight Elevation in water
      numTries=5*cNumberPlayers;
      failCount=0;
      for(j=0; <numTries)
      {
        elevID=rmCreateArea("waterwrinkle"+i+"_"+j);
        rmSetAreaSize(elevID, rmAreaTilesToFraction(5), rmAreaTilesToFraction(25));
        rmSetAreaWarnFailure(elevID, false);
        rmSetAreaBaseHeight(elevID, rmRandFloat(0.1, 0.25));
        rmSetAreaTerrainType(elevID, island4TerrainType);
//      rmAddAreaTerrainLayer(elevID, "GrassDirt25", 0, 1);
        rmSetAreaMinBlobs(elevID, 1);
        rmSetAreaMaxBlobs(elevID, 3);
        rmSetAreaHeightBlend(elevID, 1.0);
        rmSetAreaMinBlobDistance(elevID, 2.0);
        rmSetAreaMaxBlobDistance(elevID, 10.0);
        rmSetAreaCoherence(elevID, 0.0);
        rmAddAreaConstraint(elevID, wrinkleLand);

        if(rmBuildArea(elevID)==false)
        {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
            break;
         else
	    failCount=0;
        }
      }


// whales 
   int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", bigFishType, 40);
   int whaleLand = rmCreateTerrainDistanceConstraint("whale land", "land", true, 25.0);

   int whaleID=rmCreateObjectDef("whale");
   rmAddObjectDefItem(whaleID, bigFishType, 1, 9.0);
   rmSetObjectDefMinDistance(whaleID, 0.0);
   rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
   rmAddObjectDefConstraint(whaleID, whaleLand);
   rmAddObjectDefConstraint(whaleID, edgeConstraint);
   rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);



// fish
   int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 30);
   int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);

   int fishID=rmCreateObjectDef("fish");
   rmAddObjectDefItem(fishID, fishType, 3, 9.0);
   rmSetObjectDefMinDistance(fishID, 0.0);
   rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(fishID, fishVsFishID);
   rmAddObjectDefConstraint(fishID, fishLand);
   rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);



// water deco
   int wDecoVsWDecoID=rmCreateTypeDistanceConstraint("water deco v water deco", waterDeco1Type, 20);
   int wDecoLand = rmCreateTerrainDistanceConstraint("water deco land", "land", true, 1.0);

   int wDecoID=rmCreateObjectDef("Water deco");
   rmAddObjectDefItem(wDecoID, waterDeco1Type, 10, 12.0);
   rmAddObjectDefItem(wDecoID, "Seaweed", 10, 12.0);
   rmSetObjectDefMinDistance(wDecoID, 0.0);
   rmSetObjectDefMaxDistance(wDecoID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(wDecoID, wDecoVsWDecoID);
   rmAddObjectDefConstraint(wDecoID, wDecoLand);
   rmPlaceObjectDefAtLoc(wDecoID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);



// shipwreck
   int wreckVsWreckID=rmCreateTypeDistanceConstraint("wreck v wreck", "Shipwreck", 30);
   int wreckLand = rmCreateTerrainDistanceConstraint("wreck land", "land", true, 2.0);

   int wreckID=rmCreateObjectDef("wreck");
   rmAddObjectDefItem(wreckID, "Shipwreck", 2, 12.0);
   rmSetObjectDefMinDistance(wreckID, 0.0);
   rmSetObjectDefMaxDistance(wreckID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(wreckID, wreckVsWreckID);
   rmAddObjectDefConstraint(wreckID, wreckLand);
   rmPlaceObjectDefAtLoc(wreckID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

// place the transports at last
   for (i=1; <= cNumberNonGaiaPlayers)
   {
      if(rmGetPlayerCulture(i) == cCultureGreek)
         rmPlaceObjectDefAtLoc(transportGreekID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      else if(rmGetPlayerCulture(i) == cCultureNorse)
         rmPlaceObjectDefAtLoc(transportNorseID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      else if(rmGetPlayerCulture(i) == cCultureEgyptian)
         rmPlaceObjectDefAtLoc(transportEgyptianID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }

// breakpoint;
   rmSetStatusText("",0.80);
}
