//*****************************
//* akIslandDomAI - AI script
//* Created by AK
//* 2003-1-31 to 2003-2-17
//*****************************


int gTempExplorePlanID = -1;
int gIslandHopperHoldPlan = -1; 
int gMaintainWaterTransportPlanID = -1;
int gTransportExplorePlanID = -1;
int gVillTrspIslandHopPlanID = -1;
int gVillagerTransportPlanID = -1;
int gColonizationPlanID = -1;
int gColonizationIslandID = -1;
int gIslandDomNavalUPID = -1;
int gIslandDomHuntUPID = -1;
int gIslandDomGuardUPID = -1;
int gIslandDomNavalAttackGoalID = -1;
int gIslandDomHuntAttackGoalID = -1;
int gIslandDomGuardAttackGoalID = -1;
int gIslandDomLandAttackGoal = -1;
int gLandAttackTrspPlanID = -1;
int gMaxIslandHoppers = -1;
bool gIslandHopping = false;


include "AOMDefaultAI.xs";


int akCountUnitsOnTransport()
{
   int unitFound=-1;
   int count=-1;
   static int unitQueryID=-1;

 
 //Create the query if we don't have it yet.
   if (unitQueryID < 0)
      unitQueryID=kbUnitQueryCreate("akCountUnitsOnTransport");
 //Define a query to get all matching units.
   if (unitQueryID != -1)
   {
     kbUnitQuerySetPlayerID(unitQueryID, cMyID);
     kbUnitQuerySetUnitType(unitQueryID, cUnitTypeLogicalTypeGarrisonOnBoats);
     kbUnitQuerySetState(unitQueryID, cUnitStateAlive);
   }
   else
     return(-1);
   kbUnitQueryResetResults(unitQueryID);
   return(kbUnitQueryExecute(unitQueryID));
}

// -----

int akGetNextTransport(int aInPlan=-1, bool aRestart=true)
{
   int unitFound=-1;
   static int lastCount=-1;
   static int count=-1;
   static int unitQueryID=-1;

//we define and execute the query only when the first element is retrieved     
   if (aRestart) 
   {
   //Get our water transport type.
     int transportPUID=kbTechTreeGetUnitIDTypeByFunctionIndex(cUnitFunctionWaterTransport, 0);
     if (transportPUID < 0)
       return(-1);
   
   //Create the query if we don't have it yet.
     if (unitQueryID < 0)
        unitQueryID=kbUnitQueryCreate("akGetFreeTransport");

      //Define a query to get all matching units.
	if (unitQueryID != -1)
	{
	   kbUnitQuerySetPlayerID(unitQueryID, cMyID);
	   kbUnitQuerySetUnitType(unitQueryID, transportPUID);
           kbUnitQuerySetState(unitQueryID, cUnitStateAlive);
	}
	else
  	   return(-1);
           kbUnitQueryResetResults(unitQueryID);
   	   count=kbUnitQueryExecute(unitQueryID);
           lastCount=-1;
   }
 //Find next matching unit and return its ID, or return invalid.
   for (i=lastCount+1; < count)
   {
      unitFound=kbUnitQueryGetResult(unitQueryID, i);
      int inPlan = kbUnitGetPlanID(unitFound);
      lastCount=i;
      if (inPlan == aInPlan)
        return(unitFound);
   }
        
   lastCount=-1;
   return(-1);
}


int akFindNextIsland(int aUnitType=-1, int aPlayer=0, vector aCurrentPos=vector(-1,-1,-1), bool aRestart=true)
{
   int unitFound=-1;
   static int lastCount=-1;
   static int count=-1;
   static int unitQueryID=-1;
//we define and execute the query only when the first element is retrieved  
//take care when using this with different players   
   if (aRestart) 
   {
   //Create the query if we don't have it yet.
     if (unitQueryID < 0)
       unitQueryID=kbUnitQueryCreate("findIslandQuery");

   //Define a query to get all matching units.
     if (unitQueryID != -1)
     {
        if (aPlayer >= 0)
        {
          kbUnitQuerySetPlayerID(unitQueryID, aPlayer);
        }
        kbUnitQuerySetUnitType(unitQueryID, aUnitType);
        kbUnitQuerySetState(unitQueryID, cUnitStateAlive);
     }
     else
       return(-1);

     kbUnitQueryResetResults(unitQueryID);
     if (aCurrentPos != cInvalidVector)
     {
       kbUnitQuerySetPosition(unitQueryID, aCurrentPos);
       kbUnitQuerySetAscendingSort(unitQueryID, true);
     }
     count=kbUnitQueryExecute(unitQueryID);
     lastCount=-1;
   }
 //Find next matching unit and return its ID, or return invalid.
   for (i=lastCount+1; < count)
   {
       unitFound=kbUnitQueryGetResult(unitQueryID, i);
       lastCount=i;
       return(unitFound);
   }
   lastCount=-1;
   return(-1);
}

int akIslandFinder (int aUnitType=-1, vector aCurrentPos=vector(-1,-1,-1))
{
 //Find the next island from current position to head for

 //First we are sure to find an unoccupied island
   int nextIsland=akFindNextIsland(aUnitType,0, aCurrentPos);
   if (nextIsland >= 0)
     return(nextIsland);
 //then we search for a enemy island by random
  for (i=1; <= cNumberPlayers)
  {
    int randPlayer = 1+aiRandInt(cNumberPlayers);
    if (randPlayer == cMyID)
      continue;
    if (kbIsPlayerResigned(randPlayer) ||
        kbHasPlayerLost(randPlayer))
      continue;
    if (kbIsPlayerAlly(randPlayer))
      continue;
    nextIsland=akFindNextIsland(aUnitType,randPlayer,aCurrentPos);
    if (nextIsland >= 0)
      break;
  }
  return(nextIsland);
}

int akFindUnitOnIsland(int aPlayerID = -1, int aIslandID = -1, int aUnitTypeID = -1)
{
   if (aIslandID < 0)
     return (-1);
   if (aUnitTypeID < 0)
     return (-1);

   vector islandPosition=kbUnitGetPosition(aIslandID);
   int islandAreaGroupID = kbAreaGroupGetIDByPosition (islandPosition);

   int count=-1;
   static int unitQueryID=-1;

 //Create the query if we don't have it.
   if (unitQueryID < 0)
      unitQueryID=kbUnitQueryCreate("akFindUnitsOnIsland");
   
 //Define a query to get all matching units
   if (unitQueryID != -1)
   {
     if (aPlayerID >= 0)
       kbUnitQuerySetPlayerID(unitQueryID, aPlayerID);
     else 
       kbUnitQuerySetPlayerRelation(unitQueryID, cPlayerRelationAny);
     kbUnitQuerySetAreaGroupID(unitQueryID, islandAreaGroupID);
     kbUnitQuerySetUnitType(unitQueryID, aUnitTypeID);
     kbUnitQuerySetState(unitQueryID, cUnitStateAny);
   }
   else
    return(-1);

   kbUnitQueryResetResults(unitQueryID);
   
   if (kbUnitQueryExecute(unitQueryID) > 0)
     return(kbUnitQueryGetResult(unitQueryID, 0));
   else 
     return(-1);    
}


int akCreateTransportExportPlan(string name="BUG", int startAreaID=-1, int goalAreaID=-1, 
   bool persistent=false, int transportPUID=-1, int pri=-1, int baseID=-1)
{
   aiEcho("CreateTransportPlan:  Name="+name+", Priority="+pri+".");
   aiEcho("  StartAreaID="+startAreaID+", GoalAreaID="+goalAreaID+", Persistent="+persistent+".");
   aiEcho("  TransportType="+kbGetUnitTypeName(transportPUID)+", BaseID="+baseID+".");

   //Create the plan.
   int planID=aiPlanCreate(name, cPlanTransport);
   if (planID < 0)
      return(-1);

   //Priority.
   aiPlanSetDesiredPriority(planID, pri);
   //Base.
   if (baseID >= 0)
     aiPlanSetBaseID(planID, baseID);
   //Set the areas.
   aiPlanSetVariableInt(planID, cTransportPlanPathType, 0, 1);
   aiPlanSetVariableInt(planID, cTransportPlanGatherArea, 0, startAreaID);
   aiPlanSetVariableInt(planID, cTransportPlanTargetArea, 0, goalAreaID);
//   aiPlanSetVariableVector(planID, cTransportPlanTargetPoint, 0, goalPos);
   //Default the initial position to the start area's location.
   aiPlanSetInitialPosition(planID, kbAreaGetCenter(startAreaID));
   //Transport type.
   aiPlanSetVariableInt(planID, cTransportPlanTransportTypeID, 0, transportPUID);
   //Persistent.
   aiPlanSetVariableBool(planID, cTransportPlanPersistent, 0, persistent);
   //Always add the transport unit type.
   aiPlanAddUnitType(planID, transportPUID, 1, 1, 1);
   //Activate.
   aiPlanSetActive(planID);
   aiPlanSetEscrowID(planID);

   //Done.
   return(planID);
}


//==============================================================================
// akCreateIslandDomUnitTypeGoal
//==============================================================================
int akCreateIslandDomUnitTypeGoal(string name="BUG", int goalType=-1, int unitTypeID=-1,
   int unitPickerID=-1, int repeat=-1, int minAge=-1, int maxAge=-1,
   int baseID=-1, bool allowRetreat=false)
{
   aiEcho("akCreateIslandDomUnitTypeGoal:  Name="+name+", unitTypeID="+unitTypeID+".");
   aiEcho("  UnitPickerID="+unitPickerID+", Repeat="+repeat+", baseID="+baseID+".");
   aiEcho("  MinAge="+minAge+", maxAge="+maxAge+", allowRetreat="+allowRetreat+".");

  
   if (unitTypeID < 0)
     return(-1);

 //Create the goal.
   int goalID=aiPlanCreate(name, cPlanGoal);
   if (goalID < 0)
      return(-1);
 //Priority.
   aiPlanSetDesiredPriority(goalID, 90);
 //Defend unit Type ID.
   aiPlanSetVariableInt(goalID, cGoalPlanTargetType, 0, cGoalPlanTargetTypeUnitType);
   aiPlanSetVariableInt(goalID, cGoalPlanTarget, 0, unitTypeID);
 //Base.
   if (baseID >= 0)
      aiPlanSetBaseID(goalID, baseID);
   else
      aiPlanSetVariableBool(goalID, cGoalPlanAutoUpdateBase, 0, true);

 //Attack.
   aiPlanSetAttack(goalID, true);
   aiPlanSetVariableInt(goalID, cGoalPlanGoalType, 0, goalType);
   aiPlanSetVariableBool(goalID, cGoalPlanAutoUpdateAttackPlayerID, 0, true);
 //Military.
   aiPlanSetMilitary(goalID, true);
   aiPlanSetEscrowID(goalID, cMilitaryEscrowID);
 //Ages.
   aiPlanSetVariableInt(goalID, cGoalPlanMinAge, 0, minAge);
   aiPlanSetVariableInt(goalID, cGoalPlanMaxAge, 0, maxAge);
 //Repeat.
   aiPlanSetVariableInt(goalID, cGoalPlanRepeat, 0, repeat);
 //Unit Picker.
   aiPlanSetVariableInt(goalID, cGoalPlanUnitPickerID, 0, unitPickerID);
 //Retreat.
   aiPlanSetVariableBool(goalID, cGoalPlanAllowRetreat, 0, allowRetreat);
 //better for water?
   aiPlanSetVariableBool(gIslandDomHuntAttackGoalID, cGoalPlanSetAreaGroups, 0, true);

   //Done.
   return(goalID);
}

rule akInitWaterMap
   minInterval 10
   maxInterval 20
   active
{

 //destroy the landExploreAI plans in AOMdefaultAI.xs
   if (gLandExplorePlanID >= 0)
   {
     aiPlanDestroy(gLandExplorePlanID);
     gLandExplorePlanID = -1;
   } 
   if (aiPlanGetID("Explore_SpecialGreek") >= 0)
   {
     aiPlanDestroy(aiPlanGetID("Explore_SpecialGreek"));
   }

 //set down the priority for the standard attack goals (in AOMDefaultAI)
   for (i=0; <5) // five must be enough
   {
     int landAttackGoal = aiGoalGetIDByIndex (cGoalPlanGoalTypeAttack, cPlanStateNone, false, i);
     if (landAttackGoal >= 0)
       aiPlanSetDesiredPriority(landAttackGoal, 50);
   }

 //set down the priority for the standard economy goals (in AOMDefaultAI)
   if (gGatherGoalPlanID >= 0)
     aiPlanSetDesiredPriority(gGatherGoalPlanID, 50);

 //activate the waterAI rules in AOMdefaultAI.xs
   xsEnableRule("findFish");

 //activate akIslandDomAI rules
   xsEnableRule("akIslandFind");
   xsEnableRule("akTransportHuntGoalMonitor");
   xsEnableRule("akTransportGuardGoalMonitor");
   xsEnableRule("akNavalDefenseGoalMonitor");

   aiEcho("Water enabled.");
 
 //Make temporary plan to explore with the initial transport 1
   gTempExplorePlanID=aiPlanCreate("akIslandDomTempTransportExplore", cPlanExplore);
   if (gTempExplorePlanID >= 0)
   {
      aiPlanAddUnitType(gTempExplorePlanID, kbTechTreeGetUnitIDTypeByFunctionIndex(cUnitFunctionWaterTransport, 0), 1, 1, 1);
      aiPlanSetDesiredPriority(gTempExplorePlanID, 1);
      aiPlanSetVariableBool(gTempExplorePlanID, cExplorePlanDoLoops, 0, false);
      aiPlanSetActive(gTempExplorePlanID);
      aiPlanSetEscrowID(gTempExplorePlanID);
   }

 //Make another plan to explore with the initial transport 2
   gTransportExplorePlanID=aiPlanCreate("akIslandDomTransportExplore", cPlanExplore);
   if (gTransportExplorePlanID >= 0)
   {
      aiPlanAddUnitType(gTransportExplorePlanID, kbTechTreeGetUnitIDTypeByFunctionIndex(cUnitFunctionWaterTransport, 0), 1, 1, 1);
      aiPlanSetDesiredPriority(gTransportExplorePlanID, 1);
      aiPlanSetVariableBool(gTransportExplorePlanID, cExplorePlanDoLoops, 0, false);
      aiPlanSetActive(gTransportExplorePlanID);
      aiPlanSetEscrowID(gTransportExplorePlanID);
   }

   xsDisableSelf();
}

// akAdjustTransportMaintainPlan
// =============================
// Override the settings from AOMDefaultAI for the water transport maintenance plan

rule akAdjustTransportMaintainPlan
   minInterval 60
   active
{
   if (kbGetAge() == 0)
     return;

 //Kill the standard transport maintenance plan (created by AOMDefaultAI)
   if (gMaintainWaterXPortPlanID >= 0)
   {
     aiPlanDestroy(gMaintainWaterXPortPlanID);
     gMaintainWaterXPortPlanID=-1;
   }

 //make sure our own plan is alive 
   if (gMaintainWaterTransportPlanID >= 0)
     gMaintainWaterTransportPlanID = aiPlanGetIDByTypeAndVariableType
		(cPlanTrain, cTrainPlanUnitType, 
                 kbTechTreeGetUnitIDTypeByFunctionIndex(cUnitFunctionWaterTransport, 0), true);

   gMaxIslandHoppers=2;
 //add 1 transport to maintain for each difficulty level above easy.
   gMaxIslandHoppers = gMaxIslandHoppers + aiGetWorldDifficulty();

 //activate the transport plan, if we await new transports to be trained
   if (kbUnitCount(cMyID, kbTechTreeGetUnitIDTypeByFunctionIndex(cUnitFunctionWaterTransport, 0), cUnitStateAlive) < gMaxIslandHoppers)
     xsEnableRule("akStartTransportPlan");

 //So return if all is fine (this should be after first run)
   if (gMaintainWaterTransportPlanID >= 0)
     return;

 //We create our own transport maintenance plan (in the first run)
   gMaintainWaterTransportPlanID=createSimpleMaintainPlan(
		kbTechTreeGetUnitIDTypeByFunctionIndex(cUnitFunctionWaterTransport, 0), 
	        gMaxIslandHoppers + 1, false, kbBaseGetMainID(cMyID));
   aiPlanSetDesiredPriority(gMaintainWaterTransportPlanID, 100);
//   aiPlanSetEscrowID(gMaintainWaterTransportPlanID, 0);

 //and we create an extra build plan for a dock
   createSimpleBuildPlan(cUnitTypeDock, 1, 100, false, false, 
  		         cEconomyEscrowID, kbBaseGetMainID(cMyID), 5);
} 


// akEnableColonization
// =============================
// Enable colonization of islands in later age

rule akEnableColonization
   minInterval 60
   active
{
 //nothing to do in first age 
   if (kbGetAge() < 2)
     return;

 //nothing to do in seccond age and low difficulty
   if (kbGetAge() == 2 && aiGetWorldDifficulty() < cDifficultyHard)
     return;

 //kill the transport explore plan, we don't need it anymore
   if (gTransportExplorePlanID >= 0)
   {
      aiPlanDestroy(gTransportExplorePlanID);
      gTransportExplorePlanID = -1;
   }

 //Get our water transport type.
   int transportPUID=kbTechTreeGetUnitIDTypeByFunctionIndex(cUnitFunctionWaterTransport, 0);
   if (transportPUID < 0)
      return;

 //Get our base position
   vector baseLoc = kbBaseGetLocation(cMyID, kbBaseGetMainID(cMyID));
   int baseAreaID = kbAreaGetIDByPosition(baseLoc);

 //Find the next unclaimed settlement
   int goalAreaUnitID=akFindNextIsland(cUnitTypeSettlement, 0, baseLoc);
   if (goalAreaUnitID < 0)
      return;
   int goalAreaID=kbUnitGetAreaID(goalAreaUnitID);
   aiEcho("Found settlement at: "+goalAreaID);

 //Create a colonization plan.  If it works, add the unit type(s) for building.
   if (gColonizationPlanID < 0)
   {
     gColonizationPlanID=akCreateTransportExportPlan("akColonizationTrsp", baseAreaID, 
	goalAreaID, false, transportPUID, 90, kbBaseGetMainID(cMyID));
     aiPlanAddUnitType(gColonizationPlanID, kbTechTreeGetUnitIDTypeByFunctionIndex(cUnitFunctionBuilder,0), 2, 3, 5);
     int freeTransport = akGetNextTransport(); 
     if (freeTransport >= 0)
       aiPlanAddUnit(gColonizationPlanID, freeTransport);
     aiPlanSetRequiresAllNeedUnits(gColonizationPlanID, true);
     aiPlanSetEscrowID(gColonizationPlanID, cEconomyEscrowID);
     aiPlanSetActive(gColonizationPlanID);
   }
   if (gColonizationPlanID < 0)
     return;
 //reduce the priority for the villager transport for the island hoppers
//   aiPlanSetDesiredPriority(gVillagerTransportPlanID, 60);
   gColonizationIslandID = goalAreaUnitID;
   xsEnableRule("akColonizationMonitor");
   xsDisableSelf();
}

// akColonizationMonitor
// =============================
// Monitor the colonization process

rule akColonizationMonitor
   minInterval 10
   maxInterval 20
   inactive
{
 //try again
   if (gColonizationIslandID < 0)
   {
      xsEnableRule("akEnableColonization");
      return;
   }

 //check if our transport has arrived
   int builderID = akFindUnitOnIsland(cMyID, gColonizationIslandID, kbTechTreeGetUnitIDTypeByFunctionIndex(cUnitFunctionBuilder,0));
   if (builderID < 0)
     return;
 
   vector settlementPosition=kbUnitGetPosition(gColonizationIslandID);

 //Create a base for this settlement
   if (kbUnitGetBaseID(gColonizationIslandID) < 0)
   {
   //Create a new base.
     int newBaseID=kbBaseCreate(cMyID, "Base"+kbBaseGetNextID(), settlementPosition, 75.0);
     if (newBaseID > -1)
     {
     //Figure out the front vector.
       vector baseFront=xsVectorNormalize(kbGetMapCenter()-settlementPosition);
       kbBaseSetFrontVector(cMyID, newBaseID, baseFront);
     //Military gather point.
       vector militaryGatherPoint=settlementPosition+baseFront*40.0;
       kbBaseSetMilitaryGatherPoint(cMyID, newBaseID, militaryGatherPoint);
     //Set the other flags.
       kbBaseSetMilitary(cMyID, newBaseID, true);
       kbBaseSetEconomy(cMyID, newBaseID, true);
     //Set the resource distance limit.
       kbBaseSetMaximumResourceDistance(cMyID, newBaseID, gMaximumBaseResourceDistance);
     //Add the settlement to the base.
       kbBaseAddUnit(cMyID, newBaseID, gColonizationIslandID);
       kbBaseSetSettlement(cMyID, newBaseID, true);
     //Set the main-ness of the base.

       xsEnableRule("akBuildSettlements");
     }
   }

   if (kbUnitGetBaseID(gColonizationIslandID) < 0)
      return;
 //Do we have our settlement up?
   if (akFindUnitOnIsland(cMyID, gColonizationIslandID, cUnitTypeAbstractSettlement) > 0)
   {
   //we relocate our base (for fun)
//     aiPlanSetBaseID(gGatherGoalPlanID, kbUnitGetBaseID(gColonizationIslandID)); 
     gFarmBaseID = kbUnitGetBaseID(gColonizationIslandID);
     kbBaseSetMain(cMyID, kbUnitGetBaseID(gColonizationIslandID), true);

     aiPlanSetBaseID(gVillagerTransportPlanID, kbUnitGetBaseID(gColonizationIslandID)); 
     aiPlanSetVariableInt(gVillagerTransportPlanID, cTransportPlanGatherArea, 0, kbUnitGetAreaID(gColonizationIslandID));

     aiPlanSetBaseID(gColonizationPlanID, kbUnitGetBaseID(gColonizationIslandID)); 
     aiPlanSetVariableInt(gColonizationPlanID, cTransportPlanGatherArea, 0, kbUnitGetAreaID(gColonizationIslandID));
     
   //we're done for this time
     gColonizationIslandID = -1;
     xsDisableSelf();
   //restart colonization on high difficulty
     if (aiGetWorldDifficulty() > cDifficultyModerate)
       xsEnableRule("akEnableColonization");
//     if (aiGetWorldDifficulty() >= cDifficultyModerate)
     xsEnableRule("akEnableLandAttack");
   }   
} 


// akBuildSettlements
// =============================
// Build settlement on island

rule akBuildSettlements
   minInterval 10
   inactive
{
   //Figure out if we have any active BuildSettlements.
   int numberBuildSettlementGoals=aiGoalGetNumber(cGoalPlanGoalTypeBuildSettlement, cPlanStateWorking, true);
   if (numberBuildSettlementGoals > 0)
      return;
   if (findASettlement() == false)
      return;
   
   int numberSettlements=getNumberUnits(cUnitTypeAbstractSettlement, cMyID, cUnitStateAliveOrBuilding);

   //If we're on Easy and we have 3 settlements, go away.
   if ((aiGetWorldDifficulty() == cDifficultyEasy) && (numberSettlements >= 3))
   {
      xsDisableSelf();
      return;
   }

   //Don't get too many more than our allies.
   int largestAllyCount=0;
   for (i=1; < cNumberPlayers)
   {
      if (i == cMyID)
         continue;
      if(kbIsPlayerAlly(i) == false)
         continue;
      int count=getNumberUnits(cUnitTypeAbstractSettlement, i, cUnitStateAliveOrBuilding);
      if(count > largestAllyCount)
         largestAllyCount=count;
   }
   //Count the one I want to build on.
   numberSettlements=numberSettlements+1;
   //Never have more than 2 more settlements than any ally.
   int difference=numberSettlements-largestAllyCount;
   if ((difference > 2) && (largestAllyCount!=0))
      return;

   //See if there is another human on my team.
   bool haveHumanTeammate=false;
   for (i=1; < cNumberPlayers)
   {
      if(i == cMyID)
         continue;
      //Find the human player
      if (kbIsPlayerHuman(i) != true)
         continue;

      //This player is a human ally and not resigned.
      if ((kbIsPlayerAlly(i) == true) && (kbIsPlayerResigned(i) == false))
      {
         haveHumanTeammate=true;
         break;
      }
   }
   if(haveHumanTeammate == true)
   {
      if (kbGetAge() == 2)
      {
         if (numberSettlements > 4)
            return;
      }
      else if (kbGetAge() == 3)
      {
         if (numberSettlements > 5)
            return;
      }
   }

   //Else, do it.
   createBuildSettlementGoal("akBuildSettlement", kbGetAge(), -1, kbUnitGetBaseID(gColonizationIslandID), 1, 
		             kbTechTreeGetUnitIDTypeByFunctionIndex(cUnitFunctionBuilder,0), true, 100);
}

// akIslandFind
// ============
// Find an island to start the game

rule akIslandFind
   minInterval 10
   maxInterval 20
   inactive
{
 //We wait for any island to head for
   int goalAreaUnitID=akIslandFinder(cUnitTypeNavalShipyard,kbBaseGetLocation(cMyID, kbBaseGetMainID(cMyID)));
   aiEcho("Found island at: "+goalAreaUnitID);

   if (goalAreaUnitID == -1)
     return;

 //We destroy the temp plan to free the transport
   if (gTempExplorePlanID >= 0)
   {
     aiPlanDestroy(gTempExplorePlanID);
     gTempExplorePlanID = -1;
   }

 //Kill the second transport explore plan on random or difficulty level
   if ((gTransportExplorePlanID >= 0) && (aiRandInt(5) < 2 || aiGetWorldDifficulty() > cDifficultyModerate))
   {
      aiPlanDestroy(gTransportExplorePlanID);
      gTransportExplorePlanID = -1;
   }

 //Done.
   xsEnableRule("akStartTransportPlan");
   xsDisableSelf();
} 

// akStartTransportPlan
// ====================
// Start a transport to gather villagers

rule akStartTransportPlan
   minInterval 10
   maxInterval 15
   inactive
{
 //Get our water transport type.
   int transportPUID=kbTechTreeGetUnitIDTypeByFunctionIndex(cUnitFunctionWaterTransport, 0);
   if (transportPUID < 0)
      return;

 //Get our base position
   vector baseLoc = kbBaseGetLocation(cMyID, kbBaseGetMainID(cMyID));
   int baseAreaID = kbAreaGetIDByPosition(baseLoc);

 //Get our goal position
   int goalAreaUnitID=akIslandFinder(cUnitTypeNavalShipyard, baseLoc);
   if (goalAreaUnitID < 0)
      return;
   int goalAreaID=kbUnitGetAreaID(goalAreaUnitID);
   aiEcho("Found island at: "+goalAreaID);

 //cleanup if plan is lost
   gVillagerTransportPlanID = aiPlanGetID("akVillTrsp:"+gVillagerTransportPlanID);
 //Create the villager xport plan and add the unit type(s).
   if (gVillagerTransportPlanID < 0)
     gVillagerTransportPlanID=akCreateTransportExportPlan("akVillTrsp", baseAreaID, 
	goalAreaID, true, transportPUID, 100, kbBaseGetMainID(cMyID));

   if (gVillagerTransportPlanID < 0)
     return;
   aiPlanAddUnitType(gVillagerTransportPlanID, cUnitTypeAbstractVillager, 3, 3, 3);
   int freeTransport = akGetNextTransport(); 
   if (freeTransport >= 0)
     aiPlanAddUnit(gVillagerTransportPlanID, freeTransport);
   aiPlanSetRequiresAllNeedUnits(gVillagerTransportPlanID, true);
   aiPlanSetEscrowID(gVillagerTransportPlanID, cRootEscrowID);
   aiPlanSetActive(gVillagerTransportPlanID);

 //start the rule to catch this transport
   xsEnableRule("akStartVillTrspIslandHop");

   if (aiGetWorldDifficulty() < cDifficultyHard)
     return;

 //Done.
   xsDisableSelf();
} 



// This is the part where island hopping is done
// =============================================

// akRestartIslandHopping
// ====================
// Reset the island hopping ruleset (in case of errors)

void akRestartIslandHopping(void)
{
     xsDisableRule("akStartVillTrspIslandHop");
     xsDisableRule("akNextVillTrspIslandHop");
//     xsEnableRule("akRestartIslandFind");
     xsEnableRule("akIslandFind");
     gIslandHopping=false;
}

// akDoIslandHopping
// ====================
// For each transport find an island to head for or let it explore

void akDoIslandHopping(int aInPlan = -1)
{
   gIslandHopping = true;
   int lastIsland = -1;

 //Get our base position
   vector baseLoc = kbBaseGetLocation(cMyID, kbBaseGetMainID(cMyID));
   int baseAreaID = kbAreaGetIDByPosition(baseLoc);

   int freeTransport = akGetNextTransport(aInPlan); //this call fetches the first unit for the loop
   for (i=1; >= 0) //continuous loop, controlled by breaks
   {

   //we found no free transport so we restart island hopping 
     if (freeTransport == -1 && aInPlan == -1 && i == 0)
     {
       aiEcho("Hey, no more transports!");
       akRestartIslandHopping();
       break;
     }
     if (freeTransport == -1)
       break; //this breaks the continuous loop 


   //so we have a transport found
     vector currentPos = kbUnitGetPosition(freeTransport);

   //find next island for this transport
     if (i%2 == 0)
       int nextIsland = akIslandFinder(cUnitTypeNavalShipyard,currentPos);
     else
       nextIsland = akIslandFinder(cUnitTypeNavalShipyard,baseLoc);

     if (nextIsland == -1)
     {
       aiEcho("Oops, where are the islands gone?");
//       akRestartIslandHopping();
       return;
     }
     vector nextIslandPos = kbUnitGetPosition(nextIsland);
     if (nextIslandPos != cInvalidVector)
       aiTaskUnitMove(freeTransport, nextIslandPos); 
     freeTransport = akGetNextTransport(aInPlan,false); //this call fetches the next record for this loop
   }
}

// akControlVillTrspIslandHop
// ==========================
// Control the island hopping behaviour 

rule akControlVillTrspIslandHop 
   minInterval 10
   maxInterval 15
   active
{
 //Correct the wanted number of units to the actual number of units (remove killed units)
   int actCount=aiPlanGetNumberUnits(gIslandHopperHoldPlan, kbTechTreeGetUnitIDTypeByFunctionIndex(cUnitFunctionWaterTransport, 0));
   aiPlanAddUnitType(gIslandHopperHoldPlan, 
                     kbTechTreeGetUnitIDTypeByFunctionIndex(cUnitFunctionWaterTransport, 0), actCount, actCount, actCount);
 //Nothing to do here if we have enough island hoppers
   if (actCount >= gMaxIslandHoppers)
     return;
 //Only if we have a free transport  
   int freeTransport = akGetNextTransport(-1);
   if (freeTransport < 0)    
     return;

 //and we have no valid transportPlan
   gVillagerTransportPlanID = aiPlanGetID("akVillTrsp:"+gVillagerTransportPlanID);
   if (gVillagerTransportPlanID >= 0)    
     return;
 //we start transporting
   xsEnableRule("akStartTransportPlan");
}

// akStartVillTrspIslandHop
// ==========================
// Catch a new villager transport and let it start island hopping 

rule akStartVillTrspIslandHop 
   minInterval 1
   maxInterval 2
   inactive
{
 // we wait for the goto state of the active transport plan
   if (gVillagerTransportPlanID < 0)
     return;
   if (aiPlanGetState(gVillagerTransportPlanID) != cPlanStateGoto)
     return;

 //Make explore plan to hold island hoppers 
   if (gIslandHopperHoldPlan < 0)
   {
      gIslandHopperHoldPlan=aiPlanCreate("akIslandDomHopperHold", cPlanExplore);
//      aiPlanAddUnitType(gIslandHopperHoldPlan, kbTechTreeGetUnitIDTypeByFunctionIndex(cUnitFunctionWaterTransport, 0), 1, 1, 1);
      aiPlanSetDesiredPriority(gIslandHopperHoldPlan, 1);
      aiPlanSetVariableBool(gIslandHopperHoldPlan, cExplorePlanDoLoops, 0, false);
      aiPlanSetEscrowID(gIslandHopperHoldPlan);
      aiPlanSetActive(gIslandHopperHoldPlan);
   }
   if (gIslandHopperHoldPlan >= 0)
   {

   //try to check for enough villagers on transport
     int actTrspCount=aiPlanGetNumberUnits(gIslandHopperHoldPlan, kbTechTreeGetUnitIDTypeByFunctionIndex(cUnitFunctionWaterTransport, 0));
     int actVillCount=akCountUnitsOnTransport();
     if (actTrspCount*3 > actVillCount)
       return;

   //the new transport is on the way so destroy the transport plan and start island hopping
   //for now we hope it is full of villagers
     aiPlanSetActive(gVillagerTransportPlanID, false);
     int freeTransport = akGetNextTransport(gVillagerTransportPlanID);

     actTrspCount = actTrspCount + 1;
     aiPlanAddUnitType(gIslandHopperHoldPlan, 
                       kbTechTreeGetUnitIDTypeByFunctionIndex(cUnitFunctionWaterTransport, 0), 
		       actTrspCount, actTrspCount, actTrspCount);
     aiPlanAddUnit(gIslandHopperHoldPlan, freeTransport);
     akDoIslandHopping(gIslandHopperHoldPlan);
     aiPlanDestroy(gVillagerTransportPlanID);
     gVillagerTransportPlanID=-1;
     xsEnableRule("akNextVillTrspIslandHop");
     xsDisableSelf();
   }
}

// akNextVillTrspIslandHop
// =======================
// Next island hop for all transports 

rule akNextVillTrspIslandHop 
   minInterval 20
   maxInterval 30
   inactive
{

   akDoIslandHopping(gIslandHopperHoldPlan);

}


// akNavalDefenseGoalMonitor
// =========================
// Defensive settings and train units in naval shipyards 

rule akNavalDefenseGoalMonitor
   minInterval 20
   inactive
{
   if (kbGetAge() == 0)
     return;
 //Reduce priority for standard naval attack (from AOMDefaultAI)
   int navalAttackGoal = aiPlanGetID ("Naval attack");
   if (navalAttackGoal >= 0 )
   {
     if (aiGetWorldDifficulty() < cDifficultyHard)
       aiPlanSetDesiredPriority(navalAttackGoal, 80);
     else 
       aiPlanSetDesiredPriority(navalAttackGoal, 60);
   }
 //Setup the siege weapon preference (in AOMDefaultAI)
   kbUnitPickSetPreferenceFactor(gLateUPID, cUnitTypeAbstractSiegeWeapon, 1.0);
   kbUnitPickSetCostWeight(gLateUPID, 0.25);

 //Set down the priority for the standard economy goals (from AOMDefaultAI)
   if (gGatherGoalPlanID >= 0)
     aiPlanSetDesiredPriority(gGatherGoalPlanID, 50);

 //We create a naval unit maintenance plan for each island we own
   int minShips=1 + 2 * aiGetWorldDifficulty();
   int maxShips=1 + 3 * aiGetWorldDifficulty();

   int nextIsland = akFindNextIsland(cUnitTypeNavalShipyard, cMyID);
   for (i=0; < 2*cNumberPlayers)
   {
     if (nextIsland < 0) 
       break;
   //check, if we have a plan for this island already
     int islandProtectPlanID = aiPlanGetIDByTypeAndVariableType(cPlanTrain, cTrainPlanBuildingID, 
                 nextIsland, true);
     if (islandProtectPlanID > 0)
       continue;
   //new island, without defense plan
   //What unit type to train?
     int navalMilitaryType = kbGetRandomEnabledPUID(cUnitTypeLogicalTypeNavalMilitary, cMilitaryEscrowID);
     if (navalMilitaryType >= 0)
     {
       islandProtectPlanID=createSimpleMaintainPlan(navalMilitaryType, minShips, false, -1);
       aiPlanSetDesiredPriority(islandProtectPlanID, 90);
       aiPlanSetVariableInt(islandProtectPlanID, cTrainPlanBuildingID, 0, nextIsland);
     }
   //next island from query
     nextIsland = akFindNextIsland(cUnitTypeNavalShipyard, cMyID, cInvalidVector, false);
   }

 //Whom to attack?
 //See if we have any enemy warships running around.
   int numberEnemyWarships=0;
   int strongestEnemy=-1;
  //Find the largest warships count for any of our enemies.
   for (i=0; < cNumberPlayers)
   {
      if ((kbIsPlayerEnemy(i) == true) &&
         (kbIsPlayerResigned(i) == false) &&
         (kbHasPlayerLost(i) == false))
      {
         int tempNumberEnemyWarships=kbUnitCount(i, cUnitTypeLogicalTypeNavalMilitary, cUnitStateAlive);
         //int tempNumberEnemyDocks=kbUnitCount(i, cUnitTypeDock, cUnitStateAlive);
         if (tempNumberEnemyWarships > numberEnemyWarships)
         {
            numberEnemyWarships=tempNumberEnemyWarships;
	    strongestEnemy=i;
         }
      }
   }
   if (strongestEnemy < 0) 
     return;
   
   aiSetMostHatedPlayerID(aiCalculateMostHatedPlayerID(strongestEnemy));
}

// akTransportGuardGoalMonitor
// ===========================
// Goal to defend/protect transports (never seen it working) 

rule akTransportGuardGoalMonitor
   minInterval 20
   inactive
{
 //nothing to do in first age
   if (kbGetAge() == 0)
     return;
 //nothing to do in early ages and low difficulty
   if (kbGetAge() < 2 && aiGetWorldDifficulty() < cDifficultyHard)
     return;

 //Whom to guard?
 //Look for the first transport we find.
   int freeTransport = akGetNextTransport(gIslandHopperHoldPlan);
   if (freeTransport < 0)
     return;

   int minShips=2;
   int maxShips=3;


   if (gIslandDomGuardUPID >= 0)
   {
      if (maxShips <= 0)
      {
         kbUnitPickSetMinimumNumberUnits(gIslandDomGuardUPID, 1);
         kbUnitPickSetMaximumNumberUnits(gIslandDomGuardUPID, 1);
      }
      else
      {
         kbUnitPickSetMinimumNumberUnits(gIslandDomGuardUPID, minShips);
         kbUnitPickSetMaximumNumberUnits(gIslandDomGuardUPID, maxShips);
      }
      return;
   }

   aiEcho("Creating akGuardDefendGoal.");
   gIslandDomGuardUPID=kbUnitPickCreate("akGuard");
   if (gIslandDomGuardUPID < 0)
   {
      xsDisableSelf();
      return;
   }

   kbUnitPickResetAll(gIslandDomGuardUPID);
   kbUnitPickSetPreferenceWeight(gIslandDomGuardUPID, 1.0);
   kbUnitPickSetCombatEfficiencyWeight(gIslandDomGuardUPID, 2.0);
   kbUnitPickSetCostWeight(gIslandDomGuardUPID, 2.0);
   kbUnitPickSetDesiredNumberUnitTypes(gIslandDomGuardUPID, 3, 2, true);
   kbUnitPickSetDesiredNumberBuildings(gIslandDomGuardUPID, 3);
   kbUnitPickSetDesiredNumberBuildings(gIslandDomGuardUPID, 3,1);
   kbUnitPickSetMinimumNumberUnits(gIslandDomGuardUPID, minShips);
   kbUnitPickSetMaximumNumberUnits(gIslandDomGuardUPID, maxShips);
   kbUnitPickSetAttackUnitType(gIslandDomGuardUPID, cUnitTypeLogicalTypeNavalMilitary);
   kbUnitPickSetGoalCombatEfficiencyType(gIslandDomGuardUPID, cUnitTypeLogicalTypeNavalMilitary);
   kbUnitPickSetPreferenceFactor(gIslandDomGuardUPID, cUnitTypeLogicalTypeNavalMilitary, 1.0);
   kbUnitPickSetMovementType(gIslandDomGuardUPID, cMovementTypeWater);

 //Create the guard/defend goal.
   gIslandDomGuardAttackGoalID=akCreateIslandDomUnitTypeGoal("akGuard", cGoalPlanGoalTypeDefend,
				cUnitTypeTransportShip, gIslandDomGuardUPID, -1, kbGetAge(), -1, -1, false);

   if (gIslandDomGuardAttackGoalID < 0)
   {
      xsDisableSelf();
      return;
   }
   aiPlanSetDesiredPriority(gIslandDomGuardAttackGoalID, 60);
   aiPlanSetVariableInt(gIslandDomGuardAttackGoalID, cGoalPlanBuildingTypeID, cUnitTypeNavalShipyard);
}

// akTransportHuntGoalMonitor
// ===========================
// Goal to hunt enemy transports (never seen it working) 

rule akTransportHuntGoalMonitor
   minInterval 50
   inactive
{
 //nothing to do in first age
   if (kbGetAge() == 0)
     return;
 //nothing to do in early ages and low difficulty
   if (kbGetAge() < 2 && aiGetWorldDifficulty() < cDifficultyHard)
     return;

   int minShips=3;
   int maxShips=5;

   if (gIslandDomHuntUPID >= 0)
   {
      if (maxShips <= 0)
      {
         kbUnitPickSetMinimumNumberUnits(gIslandDomHuntUPID, 1);
         kbUnitPickSetMaximumNumberUnits(gIslandDomHuntUPID, 1);
      }
      else
      {
         kbUnitPickSetMinimumNumberUnits(gIslandDomHuntUPID, minShips);
         kbUnitPickSetMaximumNumberUnits(gIslandDomHuntUPID, maxShips);
      }
      return;
   }

 //Else, create the hunt attack goal.
   aiEcho("Creating akHuntAttackGoal .");
   gIslandDomHuntUPID=kbUnitPickCreate("akHunt");
   if (gIslandDomHuntUPID < 0)
   {
      xsDisableSelf();
      return;
   }

   kbUnitPickResetAll(gIslandDomHuntUPID);
   kbUnitPickSetPreferenceWeight(gIslandDomHuntUPID, 1.0);
   kbUnitPickSetCombatEfficiencyWeight(gIslandDomHuntUPID, 2.0);
   kbUnitPickSetCostWeight(gIslandDomHuntUPID, 2.0);
   kbUnitPickSetDesiredNumberUnitTypes(gIslandDomHuntUPID, 3, 2, true);
   kbUnitPickSetMinimumNumberUnits(gIslandDomHuntUPID, minShips);
   kbUnitPickSetMaximumNumberUnits(gIslandDomHuntUPID, maxShips);
   kbUnitPickSetAttackUnitType(gIslandDomHuntUPID, cUnitTypeLogicalTypeNavalMilitary);
   kbUnitPickSetGoalCombatEfficiencyType(gIslandDomHuntUPID, cUnitTypeLogicalTypeNavalMilitary);
   kbUnitPickSetPreferenceFactor(gIslandDomHuntUPID, cUnitTypeLogicalTypeNavalMilitary, 1.0);
   kbUnitPickSetMovementType(gIslandDomHuntUPID, cMovementTypeWater);

 //Create the hunt goal.
   gIslandDomHuntAttackGoalID=akCreateIslandDomUnitTypeGoal("akHunt", cGoalPlanGoalTypeAttack,
				cUnitTypeTransportShip, gIslandDomHuntUPID, -1, kbGetAge(), -1, -1, false);
   if (gIslandDomHuntAttackGoalID < 0)
   {
      xsDisableSelf();
      return;
   }
   aiPlanSetDesiredPriority(gIslandDomHuntAttackGoalID, 60);
   aiPlanSetVariableInt(gIslandDomHuntAttackGoalID, cGoalPlanBuildingTypeID, cUnitTypeNavalShipyard);

}

// akEnableLandAttack
// ==================
// Enable land attacks, help with extra transport plan (never seen it working)

rule akEnableLandAttack
   minInterval 20
   inactive
{
 //nothing to do in first age
   if (kbGetAge() == 0)
     return;
 //nothing to do in early ages and low difficulty
   if (kbGetAge() < 2 && aiGetWorldDifficulty() < cDifficultyHard)
     return;

   if (gIslandDomLandAttackGoal >= 0)
     return;
   int gIslandDomLandAttackGoal = akIslandFinder(cUnitTypeSettlement,kbBaseGetLocation(cMyID, kbBaseGetMainID(cMyID)));

   int   attackID=aiPlanCreate("akLandAttackOnIsland "+gIslandDomLandAttackGoal, cPlanAttack);
   if (attackID < 0)
   {
      return;
   }
   if (aiPlanSetVariableInt(attackID, cAttackPlanPlayerID, 0, 1) == false)
   {
      return;
   }
   if (aiPlanSetNumberVariableValues(attackID, cAttackPlanTargetTypeID, 1, true) == false)
   {
      return;
   }
   // add "unit" to attack list
   aiPlanSetVariableInt(attackID, cAttackPlanTargetTypeID, 0, cUnitTypeUnit);

   aiPlanSetVariableVector(attackID, cAttackPlanGatherPoint, 0, kbBaseGetLocation(cMyID, kbBaseGetMainID(cMyID)));
   aiPlanSetVariableFloat(attackID, cAttackPlanGatherDistance, 0, 30.0);
// mix up units
   aiPlanAddUnitType(attackID, cUnitTypeLogicalTypeIdleHero, 1, 1, 1);
   aiPlanAddUnitType(attackID, cUnitTypeLogicalTypeFavoriteMythUnit, 1, 1, 1);
   aiPlanAddUnitType(attackID, cUnitTypeLogicalTypeLandMilitary, 2, 3, 5);
   aiPlanAddUnitType(attackID, cUnitTypeAbstractSiegeWeapon, 1, 2, 3);

   aiPlanSetInitialPosition(attackID, kbBaseGetLocation(cMyID, kbBaseGetMainID(cMyID)));
   aiPlanSetUnitStance(attackID, cUnitStanceAggressive);
//   aiPlanSetRequiresAllNeedUnits(attackID, true);

   aiPlanSetNumberVariableValues( attackID, cAttackPlanTargetAreaGroups,  1, true);  
   aiPlanSetVariableInt(attackID, cAttackPlanTargetAreaGroups, 0, 
			kbAreaGroupGetIDByPosition(kbUnitGetPosition(gIslandDomLandAttackGoal)));


 //Get our water transport type.
   int transportPUID=kbTechTreeGetUnitIDTypeByFunctionIndex(cUnitFunctionWaterTransport, 0);
   if (transportPUID < 0)
      return;

 //Get our base position
   vector baseLoc = kbBaseGetLocation(cMyID, kbBaseGetMainID(cMyID));
   int baseAreaID = kbAreaGetIDByPosition(baseLoc);

 //Get our goal position
   int goalAreaID=kbUnitGetAreaID(gIslandDomLandAttackGoal);
   aiEcho("Attack island at: "+goalAreaID);

   if (gLandAttackTrspPlanID < 0)
   {
     gLandAttackTrspPlanID=akCreateTransportExportPlan("akLandAttackTrsp", baseAreaID, 
	goalAreaID, true, transportPUID, 90, kbBaseGetMainID(cMyID));

     int freeTransport = akGetNextTransport(); 
     if (freeTransport >= 0)
       aiPlanAddUnit(gLandAttackTrspPlanID, freeTransport);

     aiPlanAddUnitType(gLandAttackTrspPlanID, cUnitTypeLogicalTypeIdleHero, 1, 1, 1);
     aiPlanAddUnitType(gLandAttackTrspPlanID, cUnitTypeLogicalTypeFavoriteMythUnit, 1, 1, 1);
     aiPlanAddUnitType(gLandAttackTrspPlanID, cUnitTypeLogicalTypeLandMilitary, 2, 3, 5);
     aiPlanAddUnitType(gLandAttackTrspPlanID, cUnitTypeAbstractSiegeWeapon, 1, 2, 3);

     aiPlanSetRequiresAllNeedUnits(gLandAttackTrspPlanID, true);
     aiPlanSetEscrowID(gLandAttackTrspPlanID, cEconomyEscrowID);
     aiPlanSetActive(gLandAttackTrspPlanID);
   }
   if (gLandAttackTrspPlanID < 0)
     return;

   xsDisableSelf();
}
