//*****************************
//* akIslandDomVC - VC script
//* Created by AK, ZeroDexter
//* 2003-1-2 to 2003-1-18
//*****************************

include "basicvcnomain.xs";

int statsIntervall=120;
float lastStatsTime=0;

int baseIslands=0;
int baseLighthouse=0;
int baseSettlement=0;

int actIslands=0;
int actLighthouse=0;
int actSettlement=0;

rule akIslandDomInitStats
   minInterval 5
   maxInterval 20
   active
{
  baseIslands=trPlayerUnitCountSpecific(0, "Naval Shipyard");
  baseLighthouse=trPlayerUnitCountSpecific(0, "Lighthouse");
  baseSettlement=trPlayerUnitCountSpecific(0, "Settlement");
  xsDisableSelf();
}


int akCalcStats (int i=0)
{
  actIslands=trPlayerUnitCountSpecific(i, "Naval Shipyard");
  actLighthouse=trPlayerUnitCountSpecific(i, "Lighthouse");
  actSettlement=trPlayerUnitCountSpecific(i, "Settlement Level 1") - 1;

  float statsCount=0;
  if (baseIslands > 0 && actIslands > 0)
    statsCount = statsCount+1000*actIslands/baseIslands;
  if (baseLighthouse > 0 && actLighthouse > 0)
    statsCount = statsCount+1000*actLighthouse/baseLighthouse;
  if (baseSettlement > 0 && actSettlement > 0)
    statsCount = statsCount+1000*actSettlement/baseSettlement;
  return (statsCount);
}

rule akIslandDomStats
   minInterval 5
   maxInterval 20
   active
{
   // wait for the next time  
   if (trTimeMS() < lastStatsTime+statsIntervall*1000)
      return;
   lastStatsTime=trTimeMS(); 

   int prevPlayer = xsGetContextPlayer();
   int maxValue = 0;
   int secondValue = 0;
   int actValue = 0;
   int bestPlayer=0;
   int secondPlayer=0;
   int dispGameTime=lastStatsTime/1000/60;

   
   trChatSend(0, "In game statistics for akIslandDom at "+ dispGameTime +" minutes gameplay.");
   trChatSend(0, "MaxDom: 3000 ("+baseIslands+" I, "+baseSettlement+" S, "+baseLighthouse+ " L). ");
   for (i=1; < cNumberPlayers)
   {
      if (trPlayerActive(i))
      {
        xsSetContextPlayer(i);

        actValue = akCalcStats(i);	
        if (actValue > maxValue)
        {
          maxValue=actValue;
          bestPlayer = i;
        }
        else if (actValue > secondValue)
        {
          secondValue=actValue;
          secondPlayer = i;
        }
        trChatSend(0, "Player"+i+"Dom: "+ actValue + " ("+actIslands+" I, "+actSettlement+" S, "+actLighthouse+" L). ");
      }
      else 
        trChatSend(0, "Player "+i+" is gone.");     
   }
   xsSetContextPlayer(prevPlayer);
   if (maxValue > 0)
   {
     if (maxValue > secondValue + 2000)
       trChatSend(0, "Player " + bestPlayer + " is the only one hero!");
     else if (maxValue > secondValue + 1500)
       trChatSend(0, "Player " + bestPlayer + " rules!");
     else if (maxValue > secondValue + 1000)
       trChatSend(0, "Player " + bestPlayer + " rocks!");
     else if (maxValue > secondValue + 100)
       trChatSend(0, "Player " + bestPlayer + " is dominating!");
     else if (maxValue > secondValue + 50)
       trChatSend(0, "Player " + bestPlayer + " is leading!");
     else if (maxValue > secondValue + 5)
       trChatSend(0, "Player " + bestPlayer + " is ahead!");
   }
}



